//BilderKatalog_207d.js
// 02.06.10 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / hsa@ringier.ch
//DESCRIPTION:Erzeugt einen Bilder-Katalog mit den Bilddateien des ausgewhlten Ordners

//Ein JavaScript fr InDesign CS2, basierend auf dem Script "ImageCatalog.jsx" von Adobe
//bersetzt, optimiert und erweitert von Hans Haesler <hsa@ringier.ch>

// vorbeugenderweise das Anzeigen von Dialogen aktivieren
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// 'sufString' ist eine globale Variable, enthlt eine Liste von Suffizes
sufString= "|.psd|.tif|.ai|.jpg|.pdf|.eps|.tiff|.png|.gif|";
// den Dialog zur Ordnerauswahl anzeigen 
var selFolder = Folder.selectDialog("Den Ordner whlen, welcher die zu importierenden Bilddateien enthlt");
// den Pfad zum Quellordner bestimmen
if (selFolder != null) {
	var mainList = new Array ();
	var mainFiles = getMainFiles(selFolder, mainList);
	mainFileList = fileFilter1(mainFiles);
	var nMain = mainFileList.length;
	var allList = new Array ();
	var allFiles = getAllFiles(selFolder, allList);
	allFileList = fileFilter1(allFiles);
	var nAll = allFileList.length;
	
	var totFiles = nMain + nAll;
	
	if (totFiles != 0) {
		// den Handler aufrufen, welcher die gespeicherten Vorgaben einliest
		var defStr = getPrefs();
		// die Werte ausziehen
		if (defStr != "") {
			var catDef = defStr.split("\n");
			fMan = catDef[0];
			if (fMan == "false") {fMan = false;}
			else {fMan = true;}
			fSub = catDef[1];
			if (fSub == "false") {fSub = false;}
			else {fSub = true;}
			aSiz = catDef[2];
			if (aSiz == "false") {aSiz = false;}
			else {aSiz = true;}
			bSiz = catDef[3];
			if (bSiz == "false") {bSiz = false;}
			else {bSiz = true;}
			cSiz = catDef[4];
			if (cSiz == "false") {cSiz = false;}
			else {cSiz = true;}
			dSiz = catDef[5];
			if (dSiz == "false") {dSiz = false;}
			else {dSiz = true;}
			eSiz = catDef[6];
			if (eSiz == "false") {eSiz = false;}
			else {eSiz = true;}
			pSiz = catDef[7];
			mVal = catDef[8];
			rVal = catDef[9]*1;
			cVal = catDef[10]*1;
			vOff = catDef[11]*1;
			hOff = catDef[12]*1;
			nNam = catDef[13];
			if (nNam == "false") {nNam = false;}
			else {nNam = true;}
			fNam = catDef[14];
			if (fNam == "false") {fNam = false;}
			else {fNam = true;}
			pNam = catDef[15];
			if (pNam == "false") {pNam = false;}
			else {pNam = true;}
			sInf= catDef[16];
			if (sInf == "false") {sInf = false;}
			else {sInf = true;}
			pInf = catDef[17];
			if (pInf == "false") {pInf = false;}
			else {pInf = true;}
			tSiz = catDef[18]*1;
			jLft = catDef[19];
			if (jLft == "false") {jLft = false;}
			else {jLft = true;}
			jCnt = catDef[20];
			if (jCnt == "false") {jCnt = false;}
			else {jCnt = true;}
			jRgt = catDef[21];
			if (jRgt == "false") {jRgt = false;}
			else {jRgt = true;}
			fPrp = catDef[22];
			if (fPrp == "false") {fPrp = false;}
			else {fPrp = true;}
			sPct = catDef[23];
			if (sPct == "false") {sPct = false;}
			else {sPct = true;}
			hPct = catDef[24];
			if (hPct == "false") {hPct = false;}
			else {hPct = true;}
			fFra = catDef[25];
			if (fFra == "false") {fFra = false;}
			else {fFra = true;}
			rEmp = catDef[26];
			if (rEmp == "false") {rEmp = false;}
			else {rEmp = true;}
		}
		else {
			fMan = false;
			fSub = true;
			aSiz = false;
			bSiz = false;
			cSiz = false;
			dSiz = true;
			eSiz = false;
			pSiz = "240 180";
			mVal = "12 8 12 12";
			rVal = 3;
			cVal = 3;
			vOff = 18;
			hOff = 4;
			nNam = false;
			fNam = true;
			pNam = false;
			sInf = false;
			pInf = false;
			tSiz = 10;
			jLft = true;
			jCnt = false;
			jRgt = false;
			fPrp = false;
			sPct = true;
			hPct = false;
			fFra = false;
			rEmp = true;
		}
		// den Handler aufrufen, welcher den Dialog vorbereitet
		askUser(nMain, nAll);
		// die Einstellungen zu einer Textkette zusammensetzen
		var tmpList = new Array (fMan,fSub,aSiz,bSiz,cSiz,dSiz,eSiz,pSiz,mVal,rVal,cVal,vOff,hOff,nNam,fNam,pNam,sInf,pInf,tSiz,jLft,jCnt,jRgt,fPrp,sPct,hPct,fFra,rEmp);
		var curDef = tmpList.join("\n");
		// den Handler aufrufen, welcher das Ergebnis in eine Datei schreibt
		writeResult(curDef);
	}
	else {
		alert ("Der gewhlte Ordner enthlt keine Bilddateien, welche plaziert werden knnen.");
	}
}

// der Handler, welcher nur die Dateien des Hauptordners auflistet
function getMainFiles(selFolder, mainList) {
	var f = Folder(selFolder).getFiles();
	for(var i=0; i<f.length; i++) {
		if (f[i] instanceof Folder) {
		}
		else {
			if (f[i].name[0] != ".") {
				mainList.push(f[i]);
			}
		}
	}
	return mainList;
}

// der Handler, welcher auch die Dateien der Unterordner auflistet
function getAllFiles(selFolder, allList) {
	var f = Folder(selFolder).getFiles();
	for(var i=0; i<f.length; i++) {
		if (f[i] instanceof Folder) {
			getAllFiles(f[i], allList);
		}
		else {
			if (f[i].name[0] != ".") {
				allList.push(f[i]);
			}
		}
	}
	return allList;
}

// der erste Teil des Datei-Filters
function fileFilter1(allFiles){
	var curFileList = new Array ();
	for (var i=0; i<allFiles.length; i++) {
		curFile = allFiles[i];
		if (fileFilter2(curFile)) {
			curFileList.push(curFile);
		}
	}
	return curFileList;
}

// der zweite Teil des Datei-Filters (Mac-OS-Version) des Datei-Filters
// notwendig, weil nicht alle Dateien mit Suffizes versehen sind 
// und/oder diese manchmal vom Finder verborgen werden
function fileFilter2(curFile){
	var curFileType = curFile.type;
	switch (curFileType){
		case "JPEG":
		case "EPSF":
		case "PICT":
		case "TIFF":
		case "8BPS":
		case "GIFf":
		case "PDF ":
			return true;
			break;
		default:
		var curName = curFile.name.toLowerCase();
		try {
			var curItems = curName.split(".");
			var curSuf = "|." + curItems[(curItems.length)-1] + "|";
			if (sufString.indexOf(curSuf) != -1) {
				return true;
			}
			else {
				return false;
			}
		}
		catch (e) {
			return false;
		}
	}
}

// der Handler, welcher die Informationen vorbereitet
function getPrefs() {
	var defStr = "";
	// die Datei lesen, welche die gespeicherten Werte enthlt
	var tempFolder = Folder.temp;
	var f = File(tempFolder + "/catPrefs.txt");
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			defStr = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return defStr;
}

// der Handler, welcher den Dialog vorbereitet, anzeigt und auswertet
function askUser(nMain, nAll) {
	// Dialoge lschen, welche offen geblieben sind
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	// den Dialog vorbereiten
	var labelWidth = 150; 
	var textWidth = 156; 
	var aDialog = app.dialogs.add({name:"BilderKatalog"});
	with (aDialog.dialogColumns.add()) {
		
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Hauptordner:", minWidth:labelWidth});
					staticTexts.add({staticLabel:"" + nMain});
					staticTexts.add({staticLabel:"Bilddateien" + " "});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Unterordner inklusive:", minWidth:labelWidth});
					staticTexts.add({staticLabel:"" + nAll});
					staticTexts.add({staticLabel:"Bilddateien" + " "});
				}
				with (dialogRows.add()) {
					with (dialogColumns.add()) {
						staticTexts.add({staticLabel:"Ordnerwahl:", minWidth:labelWidth});
					}
					with (dialogColumns.add()) {
						var folButtons = radiobuttonGroups.add();
						with (folButtons) {
							radiobuttonControls.add({staticLabel:"nur Hauptordner", minWidth:textWidth, checkedState:fMan});
							radiobuttonControls.add({staticLabel:"auch Unterordner", minWidth:textWidth, checkedState:fSub});
						}
					}
				}
			}
		}
		
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					with(dialogColumns.add()) {
						staticTexts.add({staticLabel:"Seitenformat:", minWidth:labelWidth});
					}
					with (dialogColumns.add()) {
						var sizeButtons = radiobuttonGroups.add();
						with (sizeButtons) {
							radiobuttonControls.add({staticLabel:"DIN A4 hoch", checkedState:aSiz});
							radiobuttonControls.add({staticLabel:"DIN A4 quer", checkedState:bSiz});
							radiobuttonControls.add({staticLabel:"DIN A3 hoch", checkedState:cSiz});
							radiobuttonControls.add({staticLabel:"DIN A3 quer", checkedState:dSiz});
							radiobuttonControls.add({staticLabel:"benutzerdefinierte ...", minWidth:textWidth, checkedState:eSiz});
						}
					}
				}
				with (dialogRows.add()) {
					with(dialogColumns.add()) {
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"Seitenbreite und -hhe:", minWidth:labelWidth});
							var pageSizeField = textEditboxes.add({editContents:pSiz, minWidth:84});
							staticTexts.add({staticLabel:"mm"});
						}
					}
				}
				with (dialogRows.add()) {
					with (dialogColumns.add()) {
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:"Seitenrnder:", minWidth:labelWidth});
							var marginsField = textEditboxes.add({editContents:mVal, minWidth:84});
							staticTexts.add({staticLabel:"mm"});
						}
						with (dialogRows.add()) {
							staticTexts.add({staticLabel:" ", minWidth:labelWidth});
							staticTexts.add({staticLabel:"(ob, un, li, re)"});
						}
					}
				}
			}
		}
		
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Anzahl Reihen:", minWidth:labelWidth});
					var nRowsField = integerEditboxes.add({editValue:rVal, minWidth:36});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Anzahl Kolonnen:", minWidth:labelWidth});
					var nColumnsField = integerEditboxes.add({editValue:cVal, minWidth:36});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Vertikaler Abstand:", minWidth:labelWidth});
					var verticalOffsetField = realEditboxes.add({editValue:vOff, minWidth:36});
					staticTexts.add({staticLabel:"mm"});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Horizontaler Abstand:", minWidth:labelWidth});
					var horizontalOffsetField = realEditboxes.add({editValue:hOff, minWidth:36});
					staticTexts.add({staticLabel:"mm"});
				}
				with (dialogRows.add()) {
					with(dialogColumns.add()) {
						staticTexts.add({staticLabel:"Bildlegende:", minWidth:labelWidth});
					}
					with (dialogColumns.add()) {
						var labelsButtons = radiobuttonGroups.add();
						with (labelsButtons) {
							radiobuttonControls.add({staticLabel:"Keine", checkedState:nNam});
							radiobuttonControls.add({staticLabel:"Dateiname", checkedState:fNam});
							radiobuttonControls.add({staticLabel:"Ganzer Pfad", checkedState:pNam});
						}
					}
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Informationen:", minWidth:labelWidth});
					with (dialogColumns.add()) {
						var sizeInfo = checkboxControls.add({ staticLabel:"Breite mal Hhe", checkedState:sInf});
						var ppiInfo = checkboxControls.add({ staticLabel:"ppi (nur bei TIFFs)", checkedState:pInf});
					}
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Schriftgrad:", minWidth:labelWidth});
					var typeSize = realEditboxes.add({editValue:tSiz, minWidth:36});
					staticTexts.add({staticLabel:"pt  "});
				}
				with (dialogRows.add()) {
					with(dialogColumns.add()) {
						staticTexts.add({staticLabel:"Ausrichtung:", minWidth:labelWidth});
					}
					with (dialogColumns.add()) {
						var justButtons = radiobuttonGroups.add();
						with (justButtons) {
							radiobuttonControls.add({staticLabel:"Links", checkedState:jLft});
							radiobuttonControls.add({staticLabel:"Zentriert", checkedState:jCnt});
							radiobuttonControls.add({staticLabel:"Rechts", checkedState:jRgt});
						}
					}
				}
				with (dialogRows.add()) {
					with (dialogColumns.add()) {
						staticTexts.add({staticLabel:"Bilder anpassen:", minWidth:labelWidth});
					}
					with (dialogColumns.add()) {
						var fitButtons = radiobuttonGroups.add();
						with (fitButtons) {
							radiobuttonControls.add({staticLabel:"Proportional", checkedState:fPrp});
							radiobuttonControls.add({staticLabel:"Kleinstmgliches %", checkedState:sPct});
							radiobuttonControls.add({staticLabel:"100%", checkedState:hPct});
							radiobuttonControls.add({staticLabel:"Rahmen an Inhalt", minWidth:textWidth, checkedState:fFra});
						}
					}
				}
				with (dialogRows.add()) {
					var removeEmptyFramesCheckbox = checkboxControls.add({staticLabel:"Leere Rahmen entfernen", checkedState:rEmp});
				}
			}
		}
	}
	// den Dialog anzeigen und auswerten
	var dResult = aDialog.show();
	if (dResult == true) {
		var folLabel = folButtons.selectedButton;
		var folBtn = folLabel;
		if (folBtn == 0) {
			fMan = true;
			fSub = false;
		}
		else if (folBtn == 1) {
			fMan = false;
			fSub = true;
		}
		tmpSiz = pageSizeField.editContents;
		var sizeType = sizeButtons.selectedButton;
		var sBtn = sizeType;
		if (sBtn == 0) {
			aSiz = true;
			bSiz = false;
			cSiz = false;
			dSiz = false;
			eSiz = false;
			pW = 210;
			pH = 297;
		}
		else if (sBtn == 1) {
			aSiz = false;
			bSiz = true;
			cSiz = false;
			dSiz = false;
			eSiz = false;
			pW = 297;
			pH = 210;
		}
		else if (sBtn == 2) {
			aSiz = false;
			bSiz = false;
			cSiz = true;
			dSiz = false;
			eSiz = false;
			pW = 297;
			pH = 420;
		}
		else if (sBtn == 3) {
			aSiz = false;
			bSiz = false;
			cSiz = false;
			dSiz = true;
			eSiz = false;
			pW = 420;
			pH = 297;
		}
		else if (sBtn == 4) {
			aSiz = false;
			bSiz = false;
			cSiz = false;
			dSiz = false;
			eSiz = true;
			var tmpSize = tmpSiz.split(" ");
			if (tmpSize.length != 2) {
				alert ("Im benutzerdefinierten Feld bitte zwei Zahlen eintragen.");
				pSiz = tmpSiz;
				aDialog.destroy();
				exit();
			}
			pW = tmpSize[0]*1;
			if (isNaN(pW)) {
				alert ("Ungltiger Wert fr die Seitenbreite.");
				aDialog.destroy();
				exit();
			}
			pH = tmpSize[1]*1;
			if (isNaN(pH)) {
				alert ("Ungltiger Wert fr die Seitenhhe.");
				aDialog.destroy();
				exit();
			}
		}
		pSiz = tmpSiz;
		mVal = marginsField.editContents;
		var mVals = mVal.split(" ");
		if (mVals.length == 1) {
			var oneVal = mVal*1;
			if (isNaN(oneVal)) {
				alert ("Ungltiger Wert fr die Rnder.");
				aDialog.destroy();
				exit();
			}
			marY1 = marY2 = marX1 = marX2 = oneVal;
		}
		else if (mVals.length == 4) {
			marY1 = mVals[0]*1;
			if (isNaN(marY1)) {
				alert ("Ungltiger Wert fr den oberen Rand.");
				aDialog.destroy();
				exit();
			}
			marY2 = mVals[1]*1;
			if (isNaN(marY2)) {
				alert ("Ungltiger Wert fr den unteren Rand.");
				aDialog.destroy();
				exit();
			}
			marX1 = mVals[2]*1;
			if (isNaN(marX1)) {
				alert ("Ungltiger Wert fr den linken Rand.");
				aDialog.destroy();
				exit();
			}
			marX2 = mVals[3]*1;
			if (isNaN(marX2)) {
				alert ("Ungltiger Wert fr den rechten Rand.");
				aDialog.destroy();
				exit();
			}
		}
		else {
			alert ("Im Feld fr die Rnder entweder einen oder vier Werte eingeben.");
			aDialog.destroy();
			exit();
		}
		var nRows = nRowsField.editValue;
		rVal = nRows;
		var nColumns = nColumnsField.editValue;
		cVal = nColumns;
		var verticalOffset = verticalOffsetField.editValue;
		vOff = verticalOffset;
		var horizontalOffset = horizontalOffsetField.editValue;
		hOff = horizontalOffset;
		var selLabel = labelsButtons.selectedButton;
		var rBtn = selLabel;
		if (rBtn == 0) {
			nNam = true;
			fNam = false;
			pNam = false;
		}
		else if (rBtn == 1) {
			nNam = false;
			fNam = true;
			pNam = false;
		}
		else if (rBtn == 2) {
			nNam = false;
			fNam = false;
			pNam = true;
		}
		sInf = sizeInfo.checkedState;
		pInf= ppiInfo.checkedState;
		tSiz = typeSize.editValue;
		var justType = justButtons.selectedButton;
		var jBtn = justType;
		if (jBtn == 0) {
			jLft = true;
			jCnt = false;
			jRgt = false;
			txtJust = Justification.leftAlign;
		}
		else if (jBtn == 1) {
			jLft = false;
			jCnt = true;
			jRgt = false;
			txtJust = Justification.centerAlign;
		}
		else if (jBtn == 2) {
			jLft = false;
			jCnt = false;
			jRgt = true;
			txtJust = Justification.rightAlign;
		}
		var fitType = fitButtons.selectedButton;
		var fBtn = fitType;
		if (fBtn == 0) {
			fPrp = true;
			sPct = false;
			hPct = false;
			fFra = false;
		}
		else if (fBtn == 1) {
			fPrp = false
			sPct = true;
			hPct = false;
			fFra = false;
		}
		else if (fBtn == 2) {
			fPrp = false;
			sPct = false;
			hPct = true;
			fFra = false;
		}
		else if (fBtn == 3) {
			fPrp = false;
			sPct = false;
			hPct = false;
			fFra = true;
		}
		var removeEmptyFrames = removeEmptyFramesCheckbox.checkedState;
		rEmp = removeEmptyFrames;
		if (folBtn == 0) {
			defList = mainFileList;
		}
		else {
			defList = allFileList;
		}
		defList.sort();
		makeImageCatalog(defList, nRows, nColumns, selLabel, sInf, pInf, removeEmptyFrames, horizontalOffset, verticalOffset);
	}
	else {
		aDialog.destroy();
		exit();
	}
	aDialog.destroy();
}

// das Ergebnis in eine Datei schreiben
function writeResult(curDef) {
	var tempFolder = Folder.temp;
	var f = File(tempFolder + "/catPrefs.txt");
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.encoding = "ISO-8851-9" 
			f.write(curDef);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}

// der Handler, welcher das Dokument und die Rahmen erzeugt, 
// die Bilder importiert und bei Bedarf die Bildlegenden einsetzt
function makeImageCatalog(defList, nRows, nColumns, selLabel, sInf, pInf, removeEmptyFrames, horizontalOffset, verticalOffset){
	var curPage, curFile, x1, y1, x2, y2, curRect, labelStyle, labelLayer;
	var framesPerPage = nRows * nColumns;
	var marginPrefs = app.marginPreferences;
	var oldY1 = marginPrefs.top;
	var oldX1 = marginPrefs.left;
	var oldY2 = marginPrefs.bottom;
	var oldX2 = marginPrefs.right;
	marginPrefs.top = marY1;
	marginPrefs.left = marX1;
	marginPrefs.bottom = marY2;
	marginPrefs.right = marX2;
	var curDoc = app.documents.add();
	app.marginPreferences.top = oldY1;
	app.marginPreferences.left = oldX1;
	app.marginPreferences.bottom = oldY2;
	app.marginPreferences.right = oldX2;
	curDoc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.millimeters;
	curDoc.viewPreferences.verticalMeasurementUnits = MeasurementUnits.millimeters;
	var docPrefs = curDoc.documentPreferences;
	var nFrames = defList.length;
	var nPages = Math.round(nFrames / framesPerPage);
	if ((nPages * framesPerPage) < nFrames) {
		nPages++;
	}
	docPrefs.pageWidth = pW;
	docPrefs.pageHeight = pH;
	docPrefs.pagesPerDocument = nPages;
	docPrefs.facingPages = false;
	var liveWidth = (pW - ((marX1) + (marX2))) + horizontalOffset;
	var liveHeight = pH - ((marY1) + (marY2));
	var columnWidth = liveWidth / nColumns;
	var frameWidth = columnWidth - horizontalOffset;
	var rowHeight = (liveHeight / nRows);
	var frameHeight = rowHeight - verticalOffset;
	var allPages = curDoc.pages;
	if(selLabel > 0){
		// das Absatzformat "Bildlegende" erzeugen
		labelStyle = curDoc.paragraphStyles.item("Bildlegende");
		try {
			labelStyle.name;
		}
		catch (e) {
			labelStyle = curDoc.paragraphStyles.add({name:"Bildlegende"});
		}
		labelStyle.pointSize = tSiz;
		labelStyle.justification = txtJust;
		// die Ebene "Bildlegenden" erzeugen
		var labelLayer = curDoc.layers.item("Bildlegenden");
		try {
			labelLayer.name;
		}
		catch (e){
			labelLayer = curDoc.layers.add({name:"Bildlegenden"});
		}
	}
	// die Rahmen rckwrts aufbauen
	var curPage, curRect;
	for (i = curDoc.pages.length-1; i >= 0; i--) {
		curPage = allPages.item(i); 
		for (var j = nRows; j >= 1; j--) {
			y1 = marY1 + (rowHeight * (j-1));
			y2 = y1 + frameHeight;
			
			for (var k = nColumns; k >= 1; k--) {
				x1 = marX1 + (columnWidth * (k-1));
				x2 = x1 + frameWidth;
				curRect = curPage.rectangles.add(curDoc.layers.item(-1), undefined, undefined, {geometricBounds:[y1, x1, y2, x2], strokeWeight:0, strokeColor:curDoc.swatches.item("None")});
			}
		}
	}
	
	// weil die Rahmen in umgekehrter Reihenfolge erzeugt worden sind, 
	// knnen wir das Laden der Bilder vorwrts durchfhren
	var cS, rawW, rawH, imgW, imgH, curSize, curRes;
	var oldPc, newPc, pathItems, labelString, curName, curItems, curSuf;
	for (i = 0; i < nFrames; i++) {
		curFile = defList[i];
		curRect = curDoc.rectangles.item(i);
		try {
			curRect.place(File(curFile));
			cS = curRect.allGraphics[0].geometricBounds;
			rawW = cS[3]-cS[1];
			rawH = cS[2]-cS[0];
			imgW = (Math.floor(((rawW * 1000) + 0.5)))/1000;
			imgH = (Math.floor(((rawH * 1000) + 0.5)))/1000;
			curSize = imgW + " x " + imgH + " mm";
			curRes = "unbekannte";
			try {
				var curRes = curRect.allGraphics[0].actualPpi[0];
			}
			catch (e) {
			}
			var curPath = curFile.fsName.toString();
			if (curPath.indexOf("\u0300") != -1) {
				curPath = rep1(curPath);
			}
			if (curPath.indexOf("\u0301") != -1) {
				curPath = rep2(curPath);
			}
			if (curPath.indexOf("\u0302") != -1) {
				curPath = rep3(curPath);
			}
			if (curPath.indexOf("\u0303") != -1) {
				curPath = rep4(curPath);
			}
			if (curPath.indexOf("\u0308") != -1) {
				curPath = rep5(curPath);
			}
			if (curPath.indexOf("\u030A") != -1) {
				curPath = rep6(curPath);
			}
			if (curPath.indexOf("\u0327") != -1) {
				curPath = rep7(curPath);
			}
			curRect.label = curPath;
			// die Anpassen-Optionen zuweisen
			if (fPrp) {
				curRect.fit(FitOptions.PROPORTIONALLY);
				curRect.fit(FitOptions.CENTER_CONTENT);
			}
			if (sPct) {
				// den Inhalt des Rahmens proportional anpassen
				curRect.fit(FitOptions.FILL_PROPORTIONALLY);
				// die Bildgrsse feststellen
				oldPc = curRect.allGraphics[0].horizontalScale;
				// den Wert um 0.5% erhhen und auf eine Nachkommastelle aufrunden
				newPc = Math.ceil((oldPc + 0.5)*10) / 10;
				// den neuen Wert zuweisen
				curRect.allGraphics[0].properties = {horizontalScale:newPc, verticalScale:newPc};
				// das Bild zentrieren
				curRect.fit(FitOptions.CENTER_CONTENT);
			}
			if (fFra) {
				curRect.fit(FitOptions.PROPORTIONALLY);
				curRect.fit(FitOptions.FRAME_TO_CONTENT);
			}
			// die Bildlegende einfgen, falls gewnscht
			if (selLabel >0) {
				x1 = curRect.geometricBounds[1];
				y1 = curRect.geometricBounds[2];
				x2 = curRect.geometricBounds[3];
				y2 = curRect.geometricBounds[2]+verticalOffset;
				if (selLabel == 1) {
					pathItems = curPath.split("/");
					labelString = pathItems[(pathItems.length)-1];
					curName = labelString.toLowerCase();
					try {
						curItems = curName.split(".");
						curSuf = curItems[(curItems.length)-1];
						if (curSuf == "tif") {
							if (sInf && pInf) {
								labelString = labelString + "\n" + curSize + "\n" + curRes + " ppi";
							}
							else if (sInf) {
								labelString = labelString + "\n" + curSize;
							}
							else if (pInf) {
								labelString = labelString + "\n" + curRes + " ppi";
							}
						}
						else {
							if (sInf) {
								labelString = labelString + "\n" + curSize;
							}
						}
					}
					catch (e) {
					}
				}
				else if (selLabel == 2) {
					labelString = curPath;
				}
				textFrame = curRect.parent.textFrames.add(labelLayer, undefined, undefined,{geometricBounds:[y1, x1, y2, x2], contents:labelString});
				textFrame.textFramePreferences.firstBaselineOffset = FirstBaseline.leadingOffset;
				textFrame.texts[0].appliedParagraphStyle = labelStyle;
			}
		}
		catch (e) {
		}
	}
	// eventuell leergebliebene Rahmen entfernen, falls gewnscht
	if (removeEmptyFrames == 1) {
		for (var i = curDoc.rectangles.length-1; i >= 0; i--) {
			if (curDoc.rectangles.item(i).contentType == ContentType.unassigned) {
				curDoc.rectangles.item(i).remove();
			}
			else {
				// sobald ein Rahmen mit Inhalt angetroffen wird, die Schleife verlassen
				break;
			}
		}
	}
}

// die Handler, welche Akzentbuchstaben in ein einzelnes Zeichen verwandeln
function rep1(curPath) {
	curPath = curPath.replace(/a\u0300/g, '').replace(/A\u0300/g, '');
	curPath = curPath.replace(/e\u0300/g, '').replace(/E\u0300/g, '');
	curPath = curPath.replace(/i\u0300/g, '').replace(/I\u0300/g, '');
	curPath = curPath.replace(/o\u0300/g, '').replace(/O\u0300/g, '');
	curPath = curPath.replace(/u\u0300/g, '').replace(/U\u0300/g, '');
	return curPath;
}

function rep2(curPath) {
	curPath = curPath.replace(/a\u0301/g, '').replace(/A\u0301/g, '');
	curPath = curPath.replace(/e\u0301/g, '').replace(/E\u0301/g, '');
	curPath = curPath.replace(/i\u0301/g, '').replace(/I\u0301/g, '');
	curPath = curPath.replace(/o\u0301/g, '').replace(/O\u0301/g, '');
	curPath = curPath.replace(/u\u0301/g, '').replace(/U\u0301/g, '');
	return curPath;
}

function rep3(curPath) {
	curPath = curPath.replace(/a\u0302/g, '').replace(/A\u0302/g, '');
	curPath = curPath.replace(/e\u0302/g, '').replace(/E\u0302/g, '');
	curPath = curPath.replace(/i\u0302/g, '').replace(/I\u0302/g, '');
	curPath = curPath.replace(/o\u0302/g, '').replace(/O\u0302/g, '');
	curPath = curPath.replace(/u\u0302/g, '').replace(/U\u0302/g, '');
	return curPath;
}

function rep4(curPath) {
	curPath = curPath.replace(/a\u0303/g, '').replace(/A\u0303/g, '');
	curPath = curPath.replace(/n\u0303/g, '').replace(/N\u0303/g, '');
	curPath = curPath.replace(/o\u0303/g, '').replace(/O\u0303/g, '');
	return curPath;
}

function rep5(curPath) {
	curPath = curPath.replace(/a\u0308/g, '').replace(/A\u0308/g, '');
	curPath = curPath.replace(/e\u0308/g, '').replace(/E\u0308/g, '');
	curPath = curPath.replace(/i\u0308/g, '').replace(/I\u0308/g, '');
	curPath = curPath.replace(/o\u0308/g, '').replace(/O\u0308/g, '');
	curPath = curPath.replace(/u\u0308/g, '').replace(/U\u0308/g, '');
	curPath = curPath.replace(/y\u0308/g, '').replace(/Y\u0308/g, '');
	return curPath;
}

function rep6(curPath) {
	curPath = curPath.replace(/a\u030A/g, '').replace(/A\u030A/g, '');
	return curPath;
}

function rep7(curPath) {
	curPath = curPath.replace(/c\u0327/g, '').replace(/C\u0327/g, '');
	return curPath;
}